﻿using System;
using System.ServiceModel.Description;
using Microsoft.Crm.Sdk.Messages;
using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Client;

// http://dotnetfollower.com
namespace dotNetFollower
{
    public class OrganizationServiceProxyEx : OrganizationServiceProxy
    {
        private WhoAmIResponse _whoAmIResponse;

        public WhoAmIResponse CurrentUser
        {
            get { return _whoAmIResponse ?? (_whoAmIResponse = (WhoAmIResponse) Execute(new WhoAmIRequest())); }
        }

        public OrganizationServiceProxyEx(IServiceConfiguration<IOrganizationService> serviceConfiguration, ClientCredentials clientCredentials)
            : base(serviceConfiguration, clientCredentials)
        {
            
        }
        public OrganizationServiceProxyEx(IServiceConfiguration<IOrganizationService> serviceConfiguration,
                                        SecurityTokenResponse securityTokenResponse)
            : base(serviceConfiguration, securityTokenResponse)
        {
            
        }
        public OrganizationServiceProxyEx(IServiceManagement<IOrganizationService> serviceManagement,
                                        ClientCredentials clientCredentials)
            : base(serviceManagement, clientCredentials)
        {
            
        }
        public OrganizationServiceProxyEx(IServiceManagement<IOrganizationService> serviceManagement,
                                        SecurityTokenResponse securityTokenResponse)
            : base(serviceManagement, securityTokenResponse)
        {
            
        }
        public OrganizationServiceProxyEx(Uri uri, Uri homeRealmUri, ClientCredentials clientCredentials,
                                        ClientCredentials deviceCredentials)
            : base(uri, homeRealmUri, clientCredentials, deviceCredentials)
        {
            
        }
    }
}
